#property strict
#include <GoldBug\!! GoldBug Winfile V2.mqh>

input string      InputFile      = "tester1.csv";
input string      OutPutFile     = """GAOptimized.CSV """;
input int         OutPutRecords  = 1000;
input string      OutputPair     = "EURUSD";
input double      MinimumProfit  = 1000.00;
input int         MinimumTrades  = 50;
input string      NeuronsPairs   = "433=27, 443=35, 552=42, 453=43, 553=48, 563=57, 4433=47, 4443=55, 4532=51, 4453=63, 4543=64, 5532=56, 5642=74, 6642=80";

string NeuronsToName[];
int OnInit()   {
   if(Split_NeuronNames()  == INIT_FAILED)   return(INIT_FAILED);
   return(INIT_SUCCEEDED);
}
int Split_NeuronNames() {
   string data[], name;
   int index, pos=0, count=0;
   StringSplit(NeuronsPairs,',',data);
   count=ArraySize(data);
   for(int i=0;i<count;i++)   {
      pos=StringFind(data[i],"=");
      index=(int)StringSubstr(data[i],pos+1);
      if(ArraySize(NeuronsToName) < index+1)     ArrayResize(NeuronsToName,index+1);
      name=StringSubstr(data[i],0,pos);
      if((int)NeuronsToName[index] >20 && NeuronsToName[index] !=name)   {Print("***Invalid NeuronsPairs entry ",data[i]," ",index," ",NeuronsToName[index]);  return(INIT_FAILED);}
      NeuronsToName[index]=name;
   }
   //Print("NeuronPairs=",NeuronsPairs);
   //for(int i=0;i<ArraySize(NeuronsToName);i++)    if((int)NeuronsToName[i] >20)  Print(__FUNCTION__," ",i," ",NeuronsToName[i]);
   //Print("Inputfile=<",InputFile,">");
   Process_CSVFile();
   return(INIT_SUCCEEDED);
}
void OnTick()  {     }
int  Process_CSVFile() {
   int trades=0, len=0, LastRecord=0, count, outputrecords=0, profitindex, tradeindex, neuronindex;
   long inputfilehandle, outputfilehandle;
	string s, datain,output[], headers[],values[], lastneuron, layers, neuronname;
   string inputpath="""C:\\Forex Program Files\\FX Choice\\DEV5\\MQL5\\Files\\""",
          outputpath="""C:\\Forex Program Files\\FX Choice\\DEV5\\MQL5\\Files\\""";
   //int l=StringFill(InputFile,' ');
   //if(l>0)Print("*** spaces in inputfilename");    
   inputfilehandle=OpenExistingFileForReading(inputpath+InputFile); 
   if(inputfilehandle < 0)   {
      Print("*** ",InputFile," did not open correctly, check name  or if file is already open in another window");
      int err=GetLastError();
      Print(InputFile,"> ",FileIsExist(InputFile),' ',inputfilehandle," ",err);
      return(INIT_FAILED);
   }
   
   s=ReadWholeFile(inputfilehandle);
   CloseFile(inputfilehandle);
   int crlf=StringFind(s,"\r\n");
   ArrayResize(output,OutPutRecords+1);
   for(int i=0;i<=OutPutRecords && crlf>0;i++)   {
      datain=StringSubstr(s,0,crlf);
      s=StringSubstr(s,crlf+2);
      if(i==0) {
         StringSplit(datain,',',headers);
         count=ArraySize(headers);
         lastneuron=headers[count-1];
         neuronindex=(int)StringSubstr(lastneuron,1)+1;
         neuronname=NeuronsToName[neuronindex];
         StringTrimLeft(neuronname);
         for(int j=0;j<count;j++) {
            if(headers[j]=="Profit")   profitindex=j;
            if(headers[j]=="Trades")   {tradeindex=j; break;}
         }
         output[outputrecords++]="Currency,Layers,Actual,"+datain;       
      } else {
         StringSplit(datain,',',values);
         if((double)values[profitindex] < MinimumProfit)   { CloseHandle(inputfilehandle);   break;   }
         if((int)values[tradeindex]  >  MinimumTrades)  output[outputrecords++]=OutputPair+","+neuronname+",XX,"+datain;
      }     
      crlf=StringFind(s,"\r\n");
   }
   
   len=StringLen(OutPutFile);
   string filename=StringSubstr(OutPutFile,0,len-5)+neuronname+StringSubstr(OutPutFile,len-5);
   outputfilehandle=OpenNewFileForWriting(outputpath+filename);
   for(int i=0;i<=outputrecords;i++)    WriteToCSVFile((int)outputfilehandle,output[i]+"\r\n");
   FileFlush((int)outputfilehandle);
   CloseFile(outputfilehandle);
   Print("Finished!!! Header Plus ",outputrecords-1," data records");

   return(INIT_SUCCEEDED);
}
